#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

class Animation
  
  def initialize(logPath)
    @logPath = logPath
    #@maPath = maPath
    @lines = File.open(@logPath, "r")
    model = Sketchup.active_model
    entities = model.active_entities
    view = model.active_view
    #camera = view.camera
    #@target = entities[0]
    Sketchup::set_status_text("Time", 1)
  end #def initialize  
  
  def nextFrame(view)
    if !@lines.eof then
      currentLine = @lines.readline
      #puts currentLine
      if currentLine.include? " Y " then
        logValue = currentLine[currentLine.index('para')-8..currentLine.index('para')-2]
        hours = currentLine[12..13]
        minutes = currentLine[15..16]
        seconds = currentLine[18..19]
        miliseconds = currentLine[21..23]
        totalTime = (hours.to_i)*3600 + (minutes.to_i)*60 + (seconds.to_i)*10 + miliseconds.to_i
        subcell = currentLine[currentLine.index(',')+1..currentLine.index(')')]
        num1 =currentLine[currentLine.index('(')+1..currentLine.index(',')-1].to_i
        num2 = subcell[0..subcell.index(',')-1].to_i
        num3 = subcell[subcell.index(',')+1..subcell.index(')')-1].to_i
        point = Geom::Point3d.new num1,num2,num3
        puts num3, logValue
        #if totalTime == 0 then
          #transform = Geom::Transformation.new point
          #model = Sketchup.active_model
          #entities = model.active_entities
          #path = "C:/Documents and Settings/egarfink/Desktop/ball.skp"
          #definitions = model.definitions
          #componentDefinitions = definitions.load path
          #instance = entities.add_instance componentDefinitions, transform
        #else
        #end
          if num3.equal?(0) then
            if logValue.equal?(2.00000) then
              transform = Geom::Transformation.new point
              model = Sketchup.active_model
              entities = model.active_entities
              path = "C:/Documents and Settings/egarfink/Desktop/humanoid.skp"
              definitions = model.definitions
              componentDefinitions = definitions.load path
              instance = entities.add_instance componentDefinitions, transform
              #else
            end
            if logValue.equal?(0.00000) then
              for i in 0..entities.length-1 do
                if entities[i].origin.equal?(point) then
                  entities.erase_entities entities[i]
                end
              end
            end
          end
      end
    end
    Sketchup::set_status_text(totalTime, 2)
    view.show_frame(0)
  end #def nextFrame

end ##class Animation

#--------------------------end of class Animation---------------------------------------

plugins = Sketchup.find_support_file("Plugins")
icon = File.join(plugins, "pictures", "log.png")
icon2 = File.join(plugins, "pictures", "ma.png")
icon3 = File.join(plugins, "pictures", "play.png")
icon4 = File.join(plugins, "pictures", "pause.png")
icon5 = File.join(plugins, "pictures", "stop.png")
tb = UI::Toolbar.new("CD++")
log = UI::Command.new("Load log file") { load_log_file() }
log.small_icon = icon
log.large_icon = icon
ma = UI::Command.new("Load MA file") { load_ma_file() }
ma.small_icon = icon2
ma.large_icon = icon2
execute= UI::Command.new("Execute event") { execute_button() }
execute.small_icon = icon3
execute.large_icon = icon3
pause = UI::Command.new("Pause") {  pause() }
pause.small_icon = icon4
pause.large_icon = icon4
stop = UI::Command.new("Stop") { Sketchup.active_model.active_view.animation = nil }
stop.small_icon = icon5
stop.large_icon = icon5
tb.add_item(log)
tb.add_item(ma)
tb.add_item(execute)
tb.add_item(pause)
tb.add_item(stop)
tb.show

def pause()
  model = Sketchup.active_model
  view = model.active_view
  view.animation.pause
  UI.messagebox "Paused"
  end
  
def load_log_file()
  @log = UI.openpanel("Open log file")
end

def load_ma_file()
  @ma = UI.openpanel("Open log file")
end

def execute_button()
  if @log
    x = File.join(@log.split('\\'))
    #y = File.join(maPath.split('\\'))
    puts x
    puts @log
    model = Sketchup.active_model
    view = model.active_view
    view.animation = Animation.new(@log)
  end
end



